import java.util.ArrayList;
import java.util.Random;

import commandcenter.CommandCenter;
import enumerate.Action;
import enumerate.State;
import structs.FrameData;
import structs.GameData;
import structs.Key;
import gameInterface.AIInterface;

public class KongFuKing implements AIInterface {
	private Key _inputKey;
	private boolean _playernumber;
	private FrameData _framedata;
	private CommandCenter _command;
	private GameData _gamedata;

	@Override
	public int initialize(GameData gameData, boolean playerNumber) {
		// TODO Auto-generated method stub
		_inputKey = new Key();
		_playernumber = playerNumber;
		_framedata = new FrameData();
		_command = new CommandCenter();
		_gamedata = gameData;
		return 0;
	}

	@Override
	public void getInformation(FrameData frameData) {
		// TODO Auto-generated method stub
		_framedata = frameData;
		_command.setFrameData(_framedata, _playernumber);
	}

	@Override
	public void processing() {
		// TODO Auto-generated method stub
		if (!_framedata.emptyFlag && _framedata.getRemainingTime() > 0) {
			int disX = _command.getDistanceX();// x轴距离
			int disY = _command.getDistanceY();// y轴距离
			State selfState = _command.getMyCharacter().getState();
			State oppState = _command.getEnemyCharacter().getState();
			if (disX < 100) {
				// 距离小于100
				if (disY > 0) {
					// 至少有一方在空中
					if ((selfState.equals(State.AIR) || selfState
							.equals(State.DOWN))) {
						// 自己在空中或倒地,则快速防御
						DoFastGuard();
					} else {
						// 对手在空中则蹲防
						if (disY < 100) {
							// 高度小于100时,防御
							CrouchGuard();
						} else {
							// 高度大于100时,提前下段攻击
							BottomAttack();
						}
					}
				} else {
					// 双方都在地面
					ThrowAttack();
				}
			} else if (disX > 100 && disX <= 300) {
				// 100到300距离
				if (selfState.equals(State.AIR) && disY > 0) {
					// 自己在空中
					DefDistanceAttack();
				} else if (disY > 0 && _command.getMyCharacter().getY() <= 0) {
					// 对手在空中,自己在地面
					AirAttack();
				} else {
					// 其他都是用远程攻击
					DistanceAttack();
				}
			} else {
				// 其他的位置,学对手的技能
				copyProcessing();
			}
		}
	}

	@Override
	public Key input() {
		// TODO Auto-generated method stub
		return _inputKey;
	}

	@Override
	public void close() {
		// TODO Auto-generated method stub

	}

	private void Do(Action _action) {
		if (!_command.getskillFlag()) {
			_inputKey.empty();
			_command.skillCancel();
			_command.commandCall(_action.toString());
		} else {
			_inputKey = _command.getSkillKey();
		}
	}

	private void ThrowAttack() {
		Random _random = new Random();
		ArrayList<Action> list = new ArrayList<Action>();
		list.add(Action.THROW_A);
		list.add(Action.THROW_B);
		Do(list.get(_random.nextInt(list.size())));
	}

	private void AirAttack() {
		Do(Action.STAND_D_DF_FB);
	}

	private void DistanceAttack() {
		Random _random = new Random();
		ArrayList<Action> list = new ArrayList<Action>();
		list.add(Action.STAND_D_DF_FA);
		if (_command.getMyCharacter().getEnergy() >= 300) {
			list.add(Action.STAND_D_DF_FC);
		}
		Do(list.get(_random.nextInt(list.size())));
	}

	private void DefDistanceAttack() {
		Random _random = new Random();
		ArrayList<Action> list = new ArrayList<Action>();
		list.add(Action.STAND_D_DB_BA);
		list.add(Action.STAND_D_DB_BB);
		list.add(FastGuard());
		Do(list.get(_random.nextInt(list.size())));
	}

	private void BottomAttack() {
		Random _random = new Random();
		ArrayList<Action> list = new ArrayList<Action>();
		list.add(Action.STAND_D_DB_BA);
		list.add(Action.STAND_D_DB_BB);
		list.add(Action.CROUCH_FA);
		list.add(Action.CROUCH_FB);
		Do(list.get(_random.nextInt(list.size())));
	}

	private void CrouchGuard() {
		Do(Action.CROUCH_GUARD);
	}

	private void DoFastGuard() {
		Do(FastGuard());
	}

	private Action FastGuard() {
		Action act;
		switch (_command.getMyCharacter().getState()) {
		case STAND:
			act = Action.STAND_GUARD;
			break;
		case CROUCH:
		case DOWN:
			act = Action.CROUCH_GUARD;
			break;
		case AIR:
			act = Action.AIR_GUARD;
			break;
		default:
			act = Action.STAND_GUARD;
			break;
		}
		return act;
	}

	private void copyProcessing() {
		boolean temp;
		// gets the opponent's Key.
		if (_playernumber) {
			_inputKey = _framedata.getKeyData().getPlayerTwo();
		} else {
			_inputKey = _framedata.getKeyData().getPlayerOne();
		}

		// swaps L and R
		temp = _inputKey.L;
		_inputKey.L = _inputKey.R;
		_inputKey.R = temp;
	}
}
